      DOUBLE PRECISION FUNCTION DZASUM( N, ZX, INCX )
*
*     takes the sum of the absolute values.
*     jack dongarra, 3/11/78.
*
*     .. Scalar Arguments ..
      INTEGER                           INCX, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16                        ZX( 1 )
*     ..
*     .. Local Scalars ..
      INTEGER                           I, IX, NINCX
      DOUBLE PRECISION                  STEMP
*     ..
*     .. External Functions ..
      DOUBLE PRECISION                  DCABS1
      EXTERNAL                          DCABS1
*     ..
*     .. Executable Statements ..
*
      DZASUM = 0.0D0
      STEMP = 0.0D0
      IF( N.LE.0 )
     $   RETURN
      IF( INCX.EQ.1 )
     $   GO TO 20
*
*        code for increment not equal to 1
*
      IX = 1
      IF( INCX.LT.0 )
     $   IX = 1 - ( N-1 )*INCX
      NINCX = IX + ( N-1 )*INCX
      DO 10 I = IX, NINCX, INCX
         STEMP = STEMP + DCABS1( ZX( IX ) )
   10 CONTINUE
      DZASUM = STEMP
      RETURN
*
*        code for increment equal to 1
*
   20 DO 30 I = 1, N
         STEMP = STEMP + DCABS1( ZX( I ) )
   30 CONTINUE
      DZASUM = STEMP
      RETURN
      END
